﻿using System;
using System.IO;
using System.Web.UI.WebControls.WebParts;
using Microsoft.SharePoint;
using Microsoft.SharePoint.Publishing;
using Microsoft.SharePoint.WebPartPages;

namespace UploadProyecto.VisualWebPart1
{
    public class Listas
    {
        public static Microsoft.SharePoint.Navigation.SPNavigationNode spnn;


        public Listas()
        {
        }


        public static void CrearBiblioteca(string biblioteca)
        {
            SPWeb miWeb = VisualWebPart1.miSitio.OpenWeb();
            try
            {
                SPListCollection misListas = miWeb.Lists;
                SPList miLista = misListas[biblioteca];

                Boolean pro = false;
                Boolean proyectos = false;
                int nodes = miWeb.Navigation.QuickLaunch.Count;
                for (int i = 0; i < nodes; i++)
                {
                    if (miWeb.Navigation.QuickLaunch[i].Title.Equals("Proyectos"))
                    {
                        pro = true;
                        try
                        {
                            if (miWeb.Navigation.QuickLaunch[i].Children.Count > 0)
                            {
                                foreach (Microsoft.SharePoint.Navigation.SPNavigationNode n in miWeb.Navigation.QuickLaunch[i].Children)
                                {
                                    if (n.Title.Equals("Biblioteca de Proyectos"))
                                    {
                                        proyectos = true;
                                        break;
                                    }
                                }
                            }
                            if (!proyectos)
                            {
                                Microsoft.SharePoint.Navigation.SPNavigationNode biblio = Microsoft.SharePoint.Publishing.Navigation.SPNavigationSiteMapNode.CreateSPNavigationNode("Biblioteca de Proyectos", "/Biblioteca de Proyectos/Forms/AllItems.aspx", NodeTypes.List, miWeb.Navigation.QuickLaunch[i].Children);
                            }
                        }
                        catch (Exception ex)
                        {
                            string a = ex.Message;
                        }
                    }
                }
                if (!pro)
                {
                    string aux2 = VisualWebPart1.aux.Replace(VisualWebPart1.miSitio.Url, "");
                    spnn = Microsoft.SharePoint.Publishing.Navigation.SPNavigationSiteMapNode.CreateSPNavigationNode("Proyectos", aux2, NodeTypes.List, miWeb.Navigation.QuickLaunch);
                    Microsoft.SharePoint.Navigation.SPNavigationNode biblio = Microsoft.SharePoint.Publishing.Navigation.SPNavigationSiteMapNode.CreateSPNavigationNode("Biblioteca de Proyectos", "/Biblioteca de Proyectos/Forms/AllItems.aspx", NodeTypes.List, spnn.Children);
                }

                //Creo un campo nuevo llamado estado, dónde se comprobará el resultado de analizar el documento
                try
                {
                    SPField field = miLista.Fields["Estado"];
                }
                catch (Exception ex)
                {
                    SPField estado = miLista.Fields.CreateNewField(SPFieldType.Note.ToString(), "Estado");
                    estado.DefaultValue = "";
                    miLista.Fields.AddFieldAsXml(estado.SchemaXml, true, SPAddFieldOptions.AddToAllContentTypes);
                    string a = ex.Message;
                }

                miLista.Update();
                miWeb.Update();
                VisualWebPart1.debugger.Text += "Biblioteca de Proyectos creada<br>";
            }
            catch (Exception ex)
            {
                string a = ex.Message;
            }
        }


        public static void CrearElemento(string nombreProyecto, string estado, string aux)
        {
            SPWeb miWeb = VisualWebPart1.miSitio.OpenWeb();
            SPList miLista = miWeb.Lists["Lista de Proyectos"];
            VisualWebPart1.debugger.Text += "Voy a crear la Lista de Proyectos si no existe<br>";
            try
            {
                //Como no puedo eliminar ni editar el SPField Título que viene por defecto, creo una vista con mis SPFields
                //añadidos antes y hago que la vista sea la vista por defecto para mi lista
                SPViewCollection viewCol = miLista.Views;
                if (miLista.DefaultView.Title != "Vista Proyecto")
                {
                    //Creo los SPFields que me interesan
                    SPField ID = miLista.Fields.CreateNewField(SPFieldType.Text.ToString(), "ID Proyecto");
                    miLista.Fields.AddFieldAsXml(ID.SchemaXml, true, SPAddFieldOptions.AddToAllContentTypes);
                    SPField titulo = miLista.Fields.CreateNewField(SPFieldType.Text.ToString(), "Título Proyecto");
                    miLista.Fields.AddFieldAsXml(titulo.SchemaXml, true, SPAddFieldOptions.AddToAllContentTypes);
                    SPField enlace = miLista.Fields.CreateNewField(SPFieldType.URL.ToString(), "Enlace al Proyecto");
                    miLista.Fields.AddFieldAsXml(enlace.SchemaXml, true, SPAddFieldOptions.AddToAllContentTypes);
                    SPField general = miLista.Fields.CreateNewField(SPFieldType.Text.ToString(), "Estado general");
                    miLista.Fields.AddFieldAsXml(general.SchemaXml, true, SPAddFieldOptions.AddToAllContentTypes);

                    System.Collections.Specialized.StringCollection collViewFields = new System.Collections.Specialized.StringCollection();
                    collViewFields.Add("ID Proyecto");
                    collViewFields.Add("Título Proyecto");
                    collViewFields.Add("Enlace al Proyecto");
                    collViewFields.Add("Estado general");
                    viewCol.Add("Vista Proyecto", collViewFields, null, 100, true, true);
                    VisualWebPart1.debugger.Text += "Lista de Proyectos creada<br>";
                }

                //Añado la lista a inicio rápido
                int nodes = miWeb.Navigation.QuickLaunch.Count;
                Boolean proyectos = false;
                for (int i = 0; i < nodes; i++)
                {
                    if (miWeb.Navigation.QuickLaunch[i].Title.Equals("Proyectos"))
                    {
                        try
                        {
                            if (miWeb.Navigation.QuickLaunch[i].Children.Count > 0)
                            {
                                foreach (Microsoft.SharePoint.Navigation.SPNavigationNode n in miWeb.Navigation.QuickLaunch[i].Children)
                                {
                                    if (n.Title.Equals("Lista de Proyectos"))
                                    {
                                        proyectos = true;
                                        break;
                                    }
                                }
                                if (!proyectos)
                                {
                                    Microsoft.SharePoint.Navigation.SPNavigationNode listaNode = Microsoft.SharePoint.Publishing.Navigation.SPNavigationSiteMapNode.CreateSPNavigationNode("Lista de Proyectos", "/Lists/Lista de Proyectos/Vista Proyecto.aspx", NodeTypes.List, miWeb.Navigation.QuickLaunch[i].Children);
                                }
                            }
                        }
                        catch (Exception ex)
                        {
                            string a = ex.Message;
                        }
                    }
                }
                
                miLista.Update();

                //Obtengo la colección de listas y añado un ListViewWebPart que mostrará mi Lista de Proyectos
                VisualWebPart1.debugger.Text += "Voy a insertar el webpart de la lista<br>";
                //En aux tengo la página .aspx en la que me encuentro y de la que voy a tomar la colección de WebParts
                string aux3 = VisualWebPart1.aux.Replace(VisualWebPart1.miSitio.Url, "");
                VisualWebPart1.debugger.Text += "Tomo los webparts de: " + aux3 + "<br>";
                //En spwp obtengo la colección de WebParts
                SPLimitedWebPartManager spwp = miWeb.GetLimitedWebPartManager(VisualWebPart1.aux, PersonalizationScope.Shared);
                //Creo un ListViewWebPart y lo asocio a mi Lista de Proyectos con su vista por defecto
                ListViewWebPart listwp = new ListViewWebPart();
                listwp.ListName = miLista.ID.ToString().ToUpper();
                listwp.ViewGuid = miLista.DefaultView.ID.ToString().ToUpper();
                string zoneID;
                //Busco en la colección de WebParts mi WebPart UploadProyecto, cuyo ID es "g_a71287eb_a268_45ef_a0cb_3a03771c463e"
                for (int i = 0; i < spwp.WebParts.Count; i++)
                {
                    //Si encuentro un WebPart con el ID deseado...
                    if (spwp.WebParts[i].DisplayTitle == "UploadProyecto")
                    {
                        //Tomo su zona, y le añado a la colección de WebParts de la página mi ListViewWebPart en la zona deseada
                        zoneID = spwp.GetZoneID(spwp.WebParts[i]);
                        VisualWebPart1.debugger.Text += "ZoneID: " + zoneID + "<br>";
                        spwp.AddWebPart(listwp, zoneID, (spwp.WebParts[i].ZoneIndex + 1));
                    }
                }
            }
            catch (Exception ex)
            {
                VisualWebPart1.debugger.Text += ex.Message + "Error en listaaaaaaaaaaaaaas<br>";
            }

            //Obtengo la colección de items de la lista y compruebo si existe un item con el nombre de nuestro proyecto
            SPListItemCollection itemsLista = miLista.GetItems();
            Boolean existeProyecto = false;
            foreach (SPListItem item in itemsLista)
            {
                if (item["Título Proyecto"].Equals(nombreProyecto))
                {
                    //Si el elemento ya existe, sólo tengo que actualizar el estado de la estructura del proyecto
                    item["Estado general"] = estado;
                    item.Update();
                    existeProyecto = true;
                }
            }

            //Si existeProyecto es falso, quiere decir que es la primera vez que se va a subir el proyecto a la web, por lo que
            //tengo que crear un nuevo item con los datos referidos al proyecto que se va a subir
            if (existeProyecto == false)
            {
                VisualWebPart1.debugger.Text += "................El proyecto no existe! Me dispongo a crearlo..............<br>";
                SPListItem nuevoItem = miLista.AddItem();
                VisualWebPart1.debugger.Text += "ID Proyecto: " + (miLista.Items.Count + 1).ToString() + "<br>";
                nuevoItem["ID Proyecto"] = (miLista.Items.Count + 1).ToString(); ;
                VisualWebPart1.debugger.Text += "Título Proyecto: " + nombreProyecto + "<br>";
                nuevoItem["Título Proyecto"] = nombreProyecto;
                string itemUrl = VisualWebPart1.miSitio.Url + "/Biblioteca%20de%20Proyectos/" + nombreProyecto;
                VisualWebPart1.debugger.Text += "Enlace al proyecto: " + itemUrl + "<br>";
                nuevoItem["Enlace al Proyecto"] = itemUrl;
                VisualWebPart1.debugger.Text += "Estado general: " + estado + "<br>";
                nuevoItem["Estado general"] = estado;
                nuevoItem.Update();
                VisualWebPart1.debugger.Text += ".................Nuevo item creado en la lista..................<br>";
            }
        }
    }
}