﻿using System;
using System.ComponentModel;
using System.IO;
using System.Runtime.InteropServices;
using System.Security;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls.WebParts;
using Microsoft.SharePoint;
using Microsoft.SharePoint.WebControls;
using Microsoft.SharePoint.WebPartPages;

[assembly: AllowPartiallyTrustedCallers]

namespace UploadProyecto.VisualWebPart1
{
    [ToolboxItemAttribute(false)]
    [Guid("2d182925-ba55-48e4-a680-d0d8de6984ef")]
    public class VisualWebPart1 : Microsoft.SharePoint.WebPartPages.WebPart
    {
        // Visual Studio might automatically update this path when you change the Visual Web Part project item.
        private const string _ascxPath = @"~/_CONTROLTEMPLATES/UploadProyecto/VisualWebPart1/VisualWebPart1UserControl.ascx";
        public static System.Web.UI.WebControls.TextBox source = new System.Web.UI.WebControls.TextBox();
        public static System.Web.UI.WebControls.Label debugger = new System.Web.UI.WebControls.Label();
        public static System.Web.UI.WebControls.Label titulo1 = new System.Web.UI.WebControls.Label();
        public static System.Web.UI.WebControls.Label excel = new System.Web.UI.WebControls.Label();
        public static System.Web.UI.WebControls.Label word = new System.Web.UI.WebControls.Label();
        public static System.Web.UI.WebControls.Label labelOW = new System.Web.UI.WebControls.Label();
        public static System.Web.UI.WebControls.Label docAbierto = new System.Web.UI.WebControls.Label();
        public static System.Web.UI.WebControls.HyperLink excelLink = new System.Web.UI.WebControls.HyperLink();
        public static System.Web.UI.WebControls.HyperLink wordLink = new System.Web.UI.WebControls.HyperLink();
        public static System.Web.UI.WebControls.HyperLink biblio = new System.Web.UI.WebControls.HyperLink();
        public static System.Web.UI.WebControls.Button boton = new System.Web.UI.WebControls.Button();
        public static System.Web.UI.WebControls.Button examinar = new System.Web.UI.WebControls.Button();
        public static string origen_str;
        public static SPSite miSitio = null;
        public static SPWeb miWeb = null;
        public static string aux;


        public VisualWebPart1()
        {
            try
            {
                //En currentSite obtengo el SPSite de mi sitio web de SharePoint
                miSitio = SPControl.GetContextSite(HttpContext.Current);
            }
            catch (Exception ex)
            {
                System.Web.UI.WebControls.Label l1 = new System.Web.UI.WebControls.Label();
                l1.Text = ex.Message;
            }
        }


        protected override void CreateChildControls()
        {
            try
            {
                using (miWeb = miSitio.OpenWeb())
                {
                    string urlcatalogs = VisualWebPart1.miSitio.Url + "/_catalogs/lt";
                    SPFolder catalogs = miWeb.GetFolder(urlcatalogs);

                    //Compruebo que en la Biblioteca de Proyectos estén subidas las plantillas
                    string urlLista = miSitio.Url + "/Biblioteca de Proyectos";
                    SPFolder folder = miWeb.GetFolder(urlLista);

                    miWeb.AllowUnsafeUpdates = true;
                    int files = catalogs.Files.Count;
                    for (int i = files; i > 0; i--)
                    {
                        SPFile file = catalogs.Files[i - 1];
                        if (file.Name.Equals("NombreProyecto_ExcelGestion.xlsx"))
                        {
                            file.MoveTo(miSitio.Url + "/" + folder.Url + "/" + file.Name);
                            //Con BreakRoleInheritance false, el archivo no ofrece acceso a usuarios que
                            //no sean propietarios ni administradores del sitio, es decir, un usuario que sólo pueda leer
                            //no podrá ni descargar el archivo. ¿Eso me interesa?
                            //file.Item.BreakRoleInheritance(false);
                        }
                        else if (file.Name.Equals("NombreProyecto_PlanDeProyecto.docx"))
                        {
                            file.MoveTo(miSitio.Url + "/" + folder.Url + "/" + file.Name);
                            //file.Item.BreakRoleInheritance(false);
                        }
                    }
                    miWeb.AllowUnsafeUpdates = false;

                    foreach (SPFile file in folder.Files)
                    {
                        //Si encuentra la plantilla Excel añade el Label y el HyperLink a la plantilla
                        if (file.Name.Equals("NombreProyecto_ExcelGestion.xlsx"))
                        {
                            excel.Text = "<br>Si desea descargar la plantilla Excel pulse";
                            excel.Visible = true;
                            Controls.Add(excel);

                            excelLink.Text = " aquí.<br>";
                            excelLink.NavigateUrl = miSitio.Url + "/Biblioteca de Proyectos/NombreProyecto_ExcelGestion.xlsx";
                            excelLink.Visible = true;
                            Controls.Add(excelLink);
                        }
                        //Si encuentra la plantilla Word añade el Label y el HyperLink a la plantilla
                        else if (file.Name.Equals("NombreProyecto_PlanDeProyecto.docx"))
                        {
                            word.Text = "<br>Si desea descargar la plantilla Word pulse";
                            word.Visible = true;
                            Controls.Add(word);

                            wordLink.Text = " aquí.<br>";
                            wordLink.NavigateUrl = miSitio.Url + "/Biblioteca de Proyectos/NombreProyecto_PlanDeProyecto.docx";
                            wordLink.Visible = true;
                            Controls.Add(wordLink);
                        }
                    }
                }

                //Inicializo los diferentes componentes del WebPart (label - "source folder", textbox - "ruta proyecto", button - "Upload", label - "debugger")                
                titulo1.Text = "<br>Source folder:";
                Controls.Add(titulo1);

                source.Attributes.Add("id", "TextBoxSource");
                Controls.Add(source);

                //A la propiedad onclick del botón examinar, le digo que llame a la función Folder() para lanzar el javascript
                examinar.BorderColor = System.Drawing.Color.PowderBlue;
                examinar.BorderStyle = System.Web.UI.WebControls.BorderStyle.Groove;
                examinar.BackColor = System.Drawing.Color.Orange;
                examinar.Attributes.Add("onclick", "javascript: return Folder();");
                examinar.Click += new EventHandler(examinar_Click);
                examinar.Text = "Examinar";
                Controls.Add(examinar);

                boton.BorderColor = System.Drawing.Color.PowderBlue;
                boton.BorderStyle = System.Web.UI.WebControls.BorderStyle.Groove;
                boton.BackColor = System.Drawing.Color.Orange;
                boton.Click += new EventHandler(boton_Click);
                boton.Attributes.Add("id", "BotonUpload");
                boton.Text = "Upload";
                boton.Enabled = false;
                Controls.Add(boton);

                labelOW.Text = "";
                Controls.Add(labelOW);
                biblio.Text = "";
                biblio.NavigateUrl = "";
                Controls.Add(biblio);
                docAbierto.Text = "";
                Controls.Add(docAbierto);

                Controls.Add(debugger);
            }
            catch(Exception ex)
            {
                System.Web.UI.WebControls.Label l2 = new System.Web.UI.WebControls.Label();
                l2.Text = ex.Message;
            }
        }


        protected override void RenderContents(HtmlTextWriter writer)
        {
            base.RenderContents(writer);
        }


        protected override void OnLoad(EventArgs e)
        {
            //Función javascript que muestra los directorios del ordenador, de donde obtendré la carpeta del proyecto a subir
            //function Folder(){
                //var objShell = new ActiveXObject('Shell.Application');
                //var objFolder = new Object;
                //objFolder = objShell.BrowseForFolder(0, 'Select folder', 0,'::{20D04FE0-3AEA-1069-A2D8-08002B30309D}');
                //var objFolderItem = objFolder.Items().Item();
                //var objPath = objFolderItem.Path;
                //var el = document.getElementById('TextBoxSource');
                //el.value = objPath;
                ////var bt = document.getElementById('BotonUpload');
                ////bt.disabled = false;
            //}
            Page.ClientScript.RegisterStartupScript(this.GetType(), "Script", "<script language='javascript'>function Folder(){var objShell = new ActiveXObject('Shell.Application');var objFolder = new Object;objFolder = objShell.BrowseForFolder(0, 'Select folder', 0,'::{20D04FE0-3AEA-1069-A2D8-08002B30309D}');var objFolderItem = objFolder.Items().Item();var objPath = objFolderItem.Path;var el = document.getElementById('TextBoxSource');el.value = objPath;}</script>");
        }


        public void boton_Click(object sender, EventArgs e)
        {
            try
            {
                //En origen_str obtengo la ruta del proyecto que tengo que subir a la web
                debugger.Text += "<br>Aquí empieza la ejecución del programa<br>";
                origen_str = source.Text;

                aux = Page.Request.Url.ToString();
                //Llamo a la función que creará la Biblioteca de Proyectos en caso de no existir en la web
                string biblioteca = "Biblioteca de Proyectos";
                Listas.CrearBiblioteca(biblioteca);

                //Obtengo la información de la carpeta del proyecto a subir
                DirectoryInfo dir = new DirectoryInfo(origen_str);
                //Llamo a la función MoverDocumentos para comprobar que hay archivos ya subidos en la carpeta del proyecto en la web
                //y en tal caso se crea una carpeta histórico en la que se colocan los archivos
                //En los arrays de SPFiles y URLs obtengo los archivos y las URLs de la última versión correcta, por si debo recuperarlos
                //en caso de ser incorrecta la estructura de la nueva versión
                Proyecto.MoverDocumentos(miSitio.Url + "/" + biblioteca, dir.Name);

                //Llamo a la función que crea los directorios con la ruta del directorio original, la biblioteca donde quiero que los cree
                //y folder = null porque aun no he creado ninguna carpeta en la biblioteca
                Proyecto.UploadDirectory(dir, miSitio.Url + "/" + biblioteca, null);

                //Llamo a la función que comprueba la estructura del proyecto. Si es correcta, devuelve estructura = true. Si es incorrecta, deshace el MoverDocumentos
                //anterior para presentar la última versión correctamente estructurada y devuelve estructura = false
                Boolean estrucura = Estructura.ComprobarEstructura(dir.Name);

                //Con este código consigo que una vez terminado el proceso, se reinicien los arrays y el index. Si no hago esto
                //se van amontonando los valores en el arraySPFiles y termina recuperando todos los archivos de Histórico
                for (int i = 0; i < Proyecto.index; i++)
                {
                    Proyecto.arraySPFiles[i] = null;
                    Proyecto.arrayURLs[i] = null;
                }
                Proyecto.index = 0;

                //Reviso si tengo que crear el elemento en la lista o no
                if (estrucura == true)
                {
                    Listas.CrearElemento(dir.Name, "Estructura VÁLIDA", aux);
                    labelOW.Text = "<br><br>El proyecto se ha subido correctamente. Para visitarlo pulse ";
                    biblio.Text = "aquí.<br>";
                    biblio.NavigateUrl = miSitio.Url + "/Biblioteca de Proyectos/" + dir.Name;

                    if (Proyecto.abierto)
                    {
                        docAbierto.Text += "<br><br>Pero alguno de los documentos no se ha subido porque está siendo usado por otro proceso.<br>";
                    }
                }
                else
                {
                    if (Proyecto.abierto)
                    {
                        labelOW.Text = "<br><br>El proyecto no se ha subido porque uno de los documentos está siendo usado por otro proceso.<br>";
                        biblio.Text = "";
                        biblio.NavigateUrl = "";
                    }
                    else
                    {
                        if (Estructura.historico)
                        {
                            Listas.CrearElemento(dir.Name, "La última estructura es INVÁLIDA y no se ha subido el proyecto", aux);
                        }
                        labelOW.Text = "<br><br>El proyecto no se ha subido porque la estructura no era válida.<br>";
                        biblio.Text = "";
                        biblio.NavigateUrl = "";
                    }
                }

                boton.Enabled = false;
                source.Text = "";
                debugger.Text = "";

                //Me redirijo a mi misma página para que se vean los cambios de la creación de la biblioteca y la lista en inicio rápido
                //System.Web.HttpContext.Current.Response.Redirect(aux);
            }
            catch (Exception ex)
            {
                string a = ex.Message;
            }
        }


        public void examinar_Click(object sender, EventArgs e)
        {
            if (source.Text == "")
            {
                boton.Enabled = false;
            }
            else
            {
                boton.Enabled = true;
            }
        }
    }
}